PINSYSCALLS(2)

NAME
pinsyscalls - pin system call entry to precise locations in the address space

SYNOPSIS
#include <sys/types.h>
int
pinsyscalls(void *start, size_t len, u_int *pintable, int npins);

DESCRIPTION
The pinsyscalls() system call specifies the start to start + len address space range where the system call entry instructions are found, and a npins -sized array of u_int entries (indexed by the system call number) which are offsets from the start.

This provides the precise location for the system call instruction required for each system call number. Attempting to use a different system call entry instruction to perform a non-corresponding system call operation will fail with signal SIGABRT.

pinsyscalls() is only called by the shared library linker ld.so(1) to tell the kernel where system calls are found in the dynamic library libc.so (the filename is actually /usr/lib/libc.so.major.minor).

A similar setup operation is done automatically by the kernel for the system calls found in ld.so(1) and in static executables.

RETURN VALUES

ERRORS
pinsyscalls() will fail if:

[EINVAL]
    Process already has a system call pinning table loaded.

[EPERM]
    A static binary tried to call pinsyscalls().

[ERANGE]
    At least one system call offset is out of bounds.

HISTORY
The pinsyscalls() system call first appeared in OpenBSD 7.4.